commit 87823897a1afd446c5f30637a8d2d6b26cc468c2
Author: Jakub Smid <jaksmid@seznam.cz>
Date:   Tue Mar 29 14:13:10 2022 +0200

    Fixed package position for 'permission'

diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/permission/PermissionDto.java b/backend/src/main/java/cz/zcu/kiv/backendapi/permission/PermissionDto.java
new file mode 100644
index 0000000..7a783c4
--- /dev/null
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/permission/PermissionDto.java
@@ -0,0 +1,24 @@
+package cz.zcu.kiv.backendapi.permission;
+
+import lombok.Data;
+
+/**
+ * Permission DTO
+ */
+@Data
+public class PermissionDto {
+    /**
+     * Whether user has 'READ' authority
+     */
+    private boolean canRead;
+
+    /**
+     * Whether user has 'WRITE' authority
+     */
+    private boolean canWrite;
+
+    /**
+     * Whether user has 'DELETE' authority
+     */
+    private boolean canDelete;
+}
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/user/IUserService.java b/backend/src/main/java/cz/zcu/kiv/backendapi/user/IUserService.java
index 2db84bc..82adafa 100644
--- a/backend/src/main/java/cz/zcu/kiv/backendapi/user/IUserService.java
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/user/IUserService.java
@@ -1,7 +1,7 @@
 package cz.zcu.kiv.backendapi.user;
 
 import cz.zcu.kiv.backendapi.password.PasswordDto;
-import premission.PermissionDto;
+import cz.zcu.kiv.backendapi.permission.PermissionDto;
 
 import java.util.List;
 
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserController.java b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserController.java
index 6ea2fee..b284f98 100644
--- a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserController.java
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserController.java
@@ -15,7 +15,7 @@ import org.springframework.http.HttpStatus;
 import org.springframework.http.ResponseEntity;
 import org.springframework.security.core.GrantedAuthority;
 import org.springframework.web.bind.annotation.*;
-import premission.PermissionDto;
+import cz.zcu.kiv.backendapi.permission.PermissionDto;
 
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserDto.java b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserDto.java
index a529ca7..ab5e7fe 100644
--- a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserDto.java
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserDto.java
@@ -4,7 +4,7 @@ import cz.zcu.kiv.backendapi.password.PasswordDto;
 import cz.zcu.kiv.backendapi.validation.PasswordMatches;
 import cz.zcu.kiv.backendapi.validation.ValidEmail;
 import lombok.Data;
-import premission.PermissionDto;
+import cz.zcu.kiv.backendapi.permission.PermissionDto;
 
 import javax.validation.Valid;
 import javax.validation.constraints.NotEmpty;
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserServiceImpl.java b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserServiceImpl.java
index 9ce6b4d..fe8a31f 100644
--- a/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserServiceImpl.java
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/user/UserServiceImpl.java
@@ -12,7 +12,7 @@ import org.springframework.security.core.userdetails.UsernameNotFoundException;
 import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
 import org.springframework.stereotype.Service;
 import org.springframework.transaction.annotation.Transactional;
-import premission.PermissionDto;
+import cz.zcu.kiv.backendapi.permission.PermissionDto;
 
 import java.util.List;
 import java.util.stream.Collectors;
diff --git a/backend/src/main/java/premission/PermissionDto.java b/backend/src/main/java/premission/PermissionDto.java
deleted file mode 100644
index 1b0812a..0000000
--- a/backend/src/main/java/premission/PermissionDto.java
+++ /dev/null
@@ -1,24 +0,0 @@
-package premission;
-
-import lombok.Data;
-
-/**
- * Permission DTO
- */
-@Data
-public class PermissionDto {
-    /**
-     * Whether user has 'READ' authority
-     */
-    private boolean canRead;
-
-    /**
-     * Whether user has 'WRITE' authority
-     */
-    private boolean canWrite;
-
-    /**
-     * Whether user has 'DELETE' authority
-     */
-    private boolean canDelete;
-}