commit b61ca51be5a6cd4deed553425bc228aa9c37a4d7
Author: Schwobik <michal.schwob@seznam.cz>
Date:   Sun May 15 19:36:41 2022 +0200

    Updated files generated from swagger and code refactor
    re #9802

diff --git a/frontend/src/features/Catalog/CatalogItemDetail.tsx b/frontend/src/features/Catalog/CatalogItemDetail.tsx
index 763d721..5a09631 100644
--- a/frontend/src/features/Catalog/CatalogItemDetail.tsx
+++ b/frontend/src/features/Catalog/CatalogItemDetail.tsx
@@ -83,8 +83,8 @@ const CatalogItemDetail: FunctionComponent<CatalogItemDetailProps> = ({
             items: [item?.name],
         },
         {
-            rowName: 'Alternative Names',
-            items: item?.alternativeNames,
+            rowName: 'All Names',
+            items: item?.allNames,
         },
         {
             rowName: 'Written Forms',
diff --git a/frontend/src/swagger/ExternalCatalogItems.ts b/frontend/src/swagger/ExternalCatalogItems.ts
new file mode 100644
index 0000000..3cf2725
--- /dev/null
+++ b/frontend/src/swagger/ExternalCatalogItems.ts
@@ -0,0 +1,50 @@
+/* eslint-disable */
+/* tslint:disable */
+/*
+ * ---------------------------------------------------------------
+ * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
+ * ##                                                           ##
+ * ## AUTHOR: acacode                                           ##
+ * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
+ * ---------------------------------------------------------------
+ */
+
+import { ExternalCatalogItemDto } from "./data-contracts";
+import { ContentType, HttpClient, RequestParams } from "./http-client";
+
+export class ExternalCatalogItems<SecurityDataType = unknown> extends HttpClient<SecurityDataType> {
+  /**
+   * No description
+   *
+   * @tags external-catalog-controller
+   * @name GetCatalog
+   * @summary returns external catalog items based on filter
+   * @request GET:/external-catalog-items
+   */
+  getCatalog = (
+    query: { name: string; source: "PLEIADES" | "GEONAMES" | "CIGS" | "ANE" },
+    params: RequestParams = {},
+  ) =>
+    this.request<ExternalCatalogItemDto[], any>({
+      path: `/external-catalog-items`,
+      method: "GET",
+      query: query,
+      ...params,
+    });
+  /**
+   * No description
+   *
+   * @tags external-catalog-controller
+   * @name UpdateCatalog
+   * @summary updates external catalog
+   * @request POST:/external-catalog-items
+   */
+  updateCatalog = (data: { file: File }, params: RequestParams = {}) =>
+    this.request<void, any>({
+      path: `/external-catalog-items`,
+      method: "POST",
+      body: data,
+      type: ContentType.FormData,
+      ...params,
+    });
+}
diff --git a/frontend/src/swagger/Sources.ts b/frontend/src/swagger/Sources.ts
new file mode 100644
index 0000000..6d2bc1a
--- /dev/null
+++ b/frontend/src/swagger/Sources.ts
@@ -0,0 +1,46 @@
+/* eslint-disable */
+/* tslint:disable */
+/*
+ * ---------------------------------------------------------------
+ * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
+ * ##                                                           ##
+ * ## AUTHOR: acacode                                           ##
+ * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
+ * ---------------------------------------------------------------
+ */
+
+import { SourcesDto } from "./data-contracts";
+import { ContentType, HttpClient, RequestParams } from "./http-client";
+
+export class Sources<SecurityDataType = unknown> extends HttpClient<SecurityDataType> {
+  /**
+   * No description
+   *
+   * @tags sources-controller
+   * @name GetTitlePage1
+   * @summary returns sources
+   * @request GET:/sources
+   */
+  getTitlePage1 = (params: RequestParams = {}) =>
+    this.request<SourcesDto, any>({
+      path: `/sources`,
+      method: "GET",
+      ...params,
+    });
+  /**
+   * No description
+   *
+   * @tags sources-controller
+   * @name UpdateTitlePage1
+   * @summary updates/creates sources
+   * @request POST:/sources
+   */
+  updateTitlePage1 = (data: SourcesDto, params: RequestParams = {}) =>
+    this.request<void, any>({
+      path: `/sources`,
+      method: "POST",
+      body: data,
+      type: ContentType.Json,
+      ...params,
+    });
+}
diff --git a/frontend/src/swagger/data-contracts.ts b/frontend/src/swagger/data-contracts.ts
index d2e581f..4d29714 100644
--- a/frontend/src/swagger/data-contracts.ts
+++ b/frontend/src/swagger/data-contracts.ts
@@ -13,7 +13,7 @@ export interface CatalogItemDto {
   /** @format uuid */
   id?: string;
   name?: string;
-  alternativeNames?: string[];
+  allNames?: string[];
   writtenForms?: string[];
   types?: string[];
   countries?: string[];
@@ -49,10 +49,13 @@ export interface UserDto {
 }
 
 export interface TitlePageDto {
-  title?: string;
   content?: string;
 }
 
+export interface SourcesDto {
+  sources?: string;
+}
+
 export interface PathDto {
   text?: string;
   foundCatalogItems?: CatalogItemDto[][];
@@ -61,7 +64,7 @@ export interface PathDto {
 export interface ExternalCatalogItemDto {
   /** @format uuid */
   id?: string;
-  externalSource?: "PLEIADES" | "GEONAMES" | "CIGS";
+  externalSource?: "PLEIADES" | "GEONAMES" | "CIGS" | "ANE";
 
   /** @format double */
   latitude?: number;